/******************************************************************/
/* Program tworzy list jednokierunkow bez sortowania elementw. */
/* Element roboczy listy przechowuje warto typu cakowitego     */
/* oraz wskanik na nastpny element.                             */
/* Utowrzona lista jest ukierunkowana "do przodu".                */
/* Program umoliwia rwnie wywietlenie kolejnych elementw     */
/* listy, a take wywietlenie listy alfabetycznie wg nazwisk.    */
/******************************************************************/
#include <iostream.h>
#include <conio.h>
#include <string.h>
typedef struct El                       // struktura elementu roboczego
	{ char Nazwisko[30];
	  int Uposazenie;
	  struct El *Nastepny;		// wskanik do nastpnego elementu
	} ELEMENT;
typedef struct                          // struktura elementu informacyjnego
	{ ELEMENT *Glowa1;
	  ELEMENT *Ogon1;
	}INFO;
typedef struct L
	{ ELEMENT *Adres;
	  struct L *Nastepny;
	} INDEKS;
typedef struct
	{ INDEKS *Glowa2;
	  INDEKS *Ogon2;
	} IND_INFO;

int i,n;
char Nazwisko[30];
int Uposazenie;
INFO *Info1;                 // wskanik do elementu informacyjnego
IND_INFO *Info2;
void Do_Listy( char Nazwisko[], int Uposazenie);
void Pisz_Liste();
void Tworz_Indeksy();
void Indeksuj_Liste();
void Sortuj_Liste();
void main ()
{
  clrscr();
  cout << "Podaj dugo listy: ";
  cin >> n;
  Info1 = new INFO;
  Info1->Glowa1 = NULL;
  Info1->Ogon1 = NULL;
  cout << "Wprowad kolejne elementy listy:\n";
  for (i=1; i <=n; i++)
    {
      cout << i << ". ";
      cout << "Nazwisko: ";
      cin.width(30);
      cin >> Nazwisko;
      gotoxy(40, wherey() -1);
      cout << "Uposaenie: ";
      cin >> Uposazenie;
      Do_Listy(Nazwisko, Uposazenie);
    }
   cout << "\nOto lista:\n " << endl;
   Pisz_Liste();
   Tworz_Indeksy();
   Indeksuj_Liste();
   cout << "\nLista posortowana:\n";
   Sortuj_Liste();
   getch();
}


void Do_Listy(char Nazwisko[], int Uposazenie)
/* Funkcja docza nowy element do listy - na koniec listy */
{
  ELEMENT *Nowy;
  Nowy = new ELEMENT;
  if (Info1->Glowa1 == NULL)     	// doczenie nowego elementu
    {                                   // do listy pustej
      Info1->Glowa1 = Nowy;
      Info1->Ogon1 = Info1->Glowa1;
    }
    else                                // doczenie nowego elementu
     { Info1->Ogon1->Nastepny = Nowy; // na kocu listy niepustej
       Info1->Ogon1 = Nowy;
     }
   strcpy(Nowy->Nazwisko,  Nazwisko);
   Nowy->Uposazenie = Uposazenie;
   Nowy->Nastepny = NULL;
}


void Pisz_Liste()
//  Funkcja wywietla elementy listy w kierunku od pocztku do koca
{
  ELEMENT *Biezacy;
  int x,y;
  x = wherex(); y = wherey();
  gotoxy(x+3, y); cout << "Nazwisko:";
  gotoxy(40, wherey()); cout << "Uposaenie:\n" << endl;
  Biezacy = Info1->Glowa1;
  if (Info1->Glowa1 == NULL)
    cout << "Lista jest pusta\n";
    else while (Biezacy != NULL)
	    {
	      cout << Biezacy->Nazwisko;
	      gotoxy(40, wherey());
	      cout << Biezacy->Uposazenie << endl;
	      Biezacy = Biezacy->Nastepny;
	     }
}


void Tworz_Indeksy()
// Funkcja umoliwia utworzenie listy indeksw
{
  ELEMENT *Biezacy;
  INDEKS *Ind, *Przed;
    Biezacy = Info1->Glowa1;
    if (Biezacy == NULL)
      cout << "Lista jest pusta\n";
      else
	{
	 Ind = new INDEKS;
	 Info2->Glowa2 = Ind;
	 do { Ind->Adres = Biezacy;
	      Przed = Ind;
	      Info2->Ogon2 = Ind;
	      Biezacy = Biezacy->Nastepny;
	      Ind = new INDEKS;
	      Przed->Nastepny = Ind;
	      }
	  while (Biezacy != NULL);
	  Info2->Ogon2->Nastepny = NULL;
	  }
}



void Indeksuj_Liste()
// Funkcja sortuje indeksy w kolejnoci alfabetycznej nazwisk.
// Jako algorytm sortujcy wykorzystano sortowanie bbelkowe.
{
 int Zamiana;
 INDEKS *Przed, *Po, *Tym;
   do
     { Przed = Info2->Glowa2;
       Po = Przed->Nastepny;
       Zamiana = 0;
       while ( Po != NULL)
	 { if (strcmp(Przed->Adres->Nazwisko, Po->Adres->Nazwisko) > 0)
	     { Zamiana = 1;
	       Tym = new INDEKS;
	       Tym->Adres = Przed->Adres;
	       Przed->Adres = Po->Adres;
	       Po->Adres = Tym->Adres;
	      }
	    Przed = Po;
	    Po = Przed->Nastepny;
	  }
       }
     while (Zamiana == 1);
}


void Sortuj_Liste()
// Funkcja wywietla nazwiska z listy w kolejnoci alfabetycznej
{
  INDEKS *Biezacy;
    Biezacy = Info2->Glowa2;
    do {
	 cout << Biezacy->Adres->Nazwisko;
	 gotoxy(40, wherey());
	 cout << Biezacy->Adres->Uposazenie << endl;
	 Biezacy = Biezacy->Nastepny;
	}
    while (Biezacy != NULL);
}

